/***********************************************************************************************/
 /******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
 /***********************************************************************************************/

 /* $Id: $
  * This file is part of the SPHERE Pipeline
  * Copyright (C) 2007-2010 European Southern Observatory
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */
 
 /*
  * $Author: $
  * $Date: $
  * $Revision: $
  * $Name: $
  */
 
 #include "sph_error.h"
 #include "sph_cube.h"
 #include "sph_pixel_description_table.h"
 #include "sph_ldt.h"
 #include "sph_master_frame.h"
 #include "sph_double_image.h"
 #include "sph_triple_image.h"
 #include "sph_quad_image.h"
 #include "sph_zpl_exposure.h"
 #include "sph_zpl_exposure_imaging.h"
 #include "sph_pixel_polyfit_table.h"
 #include "sph_ird_instrument_model.h"
 #include "sph_fctable.h"
 #include "sph_zpl_science_pol_product.h"
 #include <cpl.h>
 #include <config.h>
 
 #ifndef SPH_ZPL_SCIENCE_P1_H_
 
 #define SPH_ZPL_SCIENCE_P1_H_
 #define SPH_ZPL_SCIENCE_P1_VERSION SPHERE_REC_VERSIONS
 
 /*-------------------------------------------------------------------------------
  * The Structure Definition
  * 
  * This structure contains the members of the sph_zpl_science_p1 that are 
  * needed by the various methods.
  * 
  * ------------------------------------------------------------------------------
  */
 
 typedef struct _sph_zpl_science_p1_ {
     cpl_frameset*                   inframes                              ; /* The recipe input frames */

     cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

     cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

     cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

     const char*                     science_p1_outfilename_q              ; /* The parameter of zpl.science_p1.outfilename_q */

     const char*                     science_p1_plus_q_outfilename         ; /* The parameter of zpl.science_p1_plus_q.outfilename */

     const char*                     science_p1_minus_q_outfilename        ; /* The parameter of zpl.science_p1_minus_q.outfilename */

     const char*                     science_p1_outfilename_u              ; /* The parameter of zpl.science_p1.outfilename_u */

     const char*                     science_p1_plus_u_outfilename         ; /* The parameter of zpl.science_p1_plus_u.outfilename */

     const char*                     science_p1_minus_u_outfilename        ; /* The parameter of zpl.science_p1_minus_u.outfilename */

     const char*                     science_p1_outfilename_q_cam1         ; /* The parameter of zpl.science_p1.outfilename_q_cam1 */

     const char*                     science_p1_plus_q_outfilename_cam1    ; /* The parameter of zpl.science_p1_plus_q_cam1.outfilename */

     const char*                     science_p1_minus_q_outfilename_cam1   ; /* The parameter of zpl.science_p1_minus_q_cam1.outfilename */

     const char*                     science_p1_outfilename_u_cam1         ; /* The parameter of zpl.science_p1.outfilename_u_cam1 */

     const char*                     science_p1_plus_u_outfilename_cam1    ; /* The parameter of zpl.science_p1_plus_u_cam1.outfilename */

     const char*                     science_p1_minus_u_outfilename_cam1   ; /* The parameter of zpl.science_p1_minus_u_cam1.outfilename */

     const char*                     science_p1_outfilename_q_cam2         ; /* The parameter of zpl.science_p1.outfilename_q_cam2 */

     const char*                     science_p1_plus_q_outfilename_cam2    ; /* The parameter of zpl.science_p1_plus_q_cam2.outfilename */

     const char*                     science_p1_minus_q_outfilename_cam2   ; /* The parameter of zpl.science_p1_minus_q_cam2.outfilename */

     const char*                     science_p1_outfilename_u_cam2         ; /* The parameter of zpl.science_p1.outfilename_u_cam2 */

     const char*                     science_p1_plus_u_outfilename_cam2    ; /* The parameter of zpl.science_p1_plus_u_cam2.outfilename */

     const char*                     science_p1_minus_u_outfilename_cam2   ; /* The parameter of zpl.science_p1_minus_u_cam2.outfilename */

     short                           subtract_overscan                     ; /* The parameter of zpl.science_p1.subtract_overscan */

     short                           keep_intermediate                     ; /* The parameter of zpl.science_p1.keep_intermediate */

     short                           save_interprod                        ; /* The parameter of zpl.science_p1.save_interprod */

     int                             coll_alg                              ; /* The parameter of zpl.science_p1.coll_alg */

     double                          filter_radius                         ; /* The parameter of zpl.science_p1.filter_radius */

     short                           star_center_iframe                    ; /* The parameter of zpl.science_p1.star_center_iframe */

     double                          center_xoffset_cam1                   ; /* The parameter of zpl.science_p1.center_xoffset_cam1 */

     double                          center_yoffset_cam1                   ; /* The parameter of zpl.science_p1.center_yoffset_cam1 */

     double                          center_xoffset_cam2                   ; /* The parameter of zpl.science_p1.center_xoffset_cam2 */

     double                          center_yoffset_cam2                   ; /* The parameter of zpl.science_p1.center_yoffset_cam2 */

     const char*                     outfilename_cam1                      ; /* The parameter of zpl.preproc.outfilename_cam1 */

     const char*                     outfilename_cam2                      ; /* The parameter of zpl.preproc.outfilename_cam2 */

     cpl_frameset*                   rawframes                             ; /* The ZPL_SCIENCE_P1_RAW frames */

     cpl_frameset*                   preproc_frames                        ; /* The ZPL_SCIENCE_P1_PREPROC frames */

     cpl_frameset*                   preproc_frames_cam1                   ; /* The ZPL_SCIENCE_P1_PREPROC_CAM1 frames */

     cpl_frameset*                   preproc_frames_cam2                   ; /* The ZPL_SCIENCE_P1_PREPROC_CAM2 frames */

     cpl_frame*                      master_bias_frame                     ; /* The ZPL_MASTER_BIAS frames */

     cpl_frame*                      master_bias_frame_cam1                ; /* The ZPL_MASTER_BIAS_CAM1 frames */

     cpl_frame*                      master_bias_frame_cam2                ; /* The ZPL_MASTER_BIAS_CAM2 frames */

     cpl_frame*                      master_dark_frame                     ; /* The ZPL_MASTER_DARK frames */

     cpl_frame*                      master_dark_frame_cam1                ; /* The ZPL_MASTER_DARK_CAM1 frames */

     cpl_frame*                      master_dark_frame_cam2                ; /* The ZPL_MASTER_DARK_CAM2 frames */

     cpl_frame*                      intensity_flat_frame                  ; /* The ZPL_INT_FLAT_FIELD frames */

     cpl_frame*                      intensity_flat_frame_cam1             ; /* The ZPL_INT_FLAT_FIELD_CAM1 frames */

     cpl_frame*                      intensity_flat_frame_cam2             ; /* The ZPL_INT_FLAT_FIELD_CAM2 frames */

     cpl_frame*                      intensity_flat_frame_master           ; /* The ZPL_INT_FLAT_FIELD_MASTER frames */

     cpl_frame*                      intensity_flat_frame_master_cam1      ; /* The ZPL_INT_FLAT_FIELD_MASTER_CAM1 frames */

     cpl_frame*                      intensity_flat_frame_master_cam2      ; /* The ZPL_INT_FLAT_FIELD_MASTER_CAM2 frames */

     cpl_frame*                      polarization_flat_frame               ; /* The ZPL_POL_FLAT_FIELD frames */

     cpl_frame*                      polarization_flat_frame_cam1          ; /* The ZPL_POL_FLAT_FIELD_CAM1 frames */

     cpl_frame*                      polarization_flat_frame_cam2          ; /* The ZPL_POL_FLAT_FIELD_CAM2 frames */

     cpl_frame*                      modem_efficiency_frame                ; /* The ZPL_MODEM_EFF frames */

     cpl_frame*                      modem_efficiency_frame_cam1           ; /* The ZPL_MODEM_EFF_CAM1 frames */

     cpl_frame*                      modem_efficiency_frame_cam2           ; /* The ZPL_MODEM_EFF_CAM2 frames */

     cpl_frame*                      star_center_frame_cam1                ; /* The ZPL_STAR_CENTER_POL_CAM1 frames */

     cpl_frame*                      star_center_frame_cam2                ; /* The ZPL_STAR_CENTER_POL_CAM2 frames */

     cpl_frame*                      star_center_frame                     ; /* The ZPL_STAR_CENTER_POL frames */

     cpl_frameset*                   fctable_frames                        ; /* The ZPL_FIELD_CENTER_TABLE frames */

     cpl_frame*                      high_polarization_std_stars_catalog   ; /* The ZPL_POLHIGH_STAR_TABLE frames */

     cpl_frame*                      filter_frame                          ; /* The ZPL_FILTER_TABLE frames */

     cpl_frame*                      std_star_pol_correction               ; /* The ZPL_POL_CORRECT_TABLE frames */

     sph_zpl_science_pol_product*    science_di_q                          ; /* The ZPL_SCIENCE_P1_REDUCED_Q product */

     sph_zpl_science_pol_product*    science_di_q_plus                     ; /* The ZPL_SCIENCE_P1_REDUCED_QPLUS product */

     sph_zpl_science_pol_product*    science_di_q_minus                    ; /* The ZPL_SCIENCE_P1_REDUCED_QMINUS product */

     sph_zpl_science_pol_product*    science_di_u                          ; /* The ZPL_SCIENCE_P1_REDUCED_U product */

     sph_zpl_science_pol_product*    science_di_u_plus                     ; /* The ZPL_SCIENCE_P1_REDUCED_UPLUS product */

     sph_zpl_science_pol_product*    science_di_u_minus                    ; /* The ZPL_SCIENCE_P1_REDUCED_UMINUS product */

     sph_zpl_science_pol_product*    science_di_q_cam1                     ; /* The ZPL_SCIENCE_P1_REDUCED_Q_CAM1 product */

     sph_zpl_science_pol_product*    science_di_q_plus_cam1                ; /* The ZPL_SCIENCE_P1_REDUCED_QPLUS_CAM1 product */

     sph_zpl_science_pol_product*    science_di_q_minus_cam1               ; /* The ZPL_SCIENCE_P1_REDUCED_QMINUS_CAM1 product */

     sph_zpl_science_pol_product*    science_di_u_cam1                     ; /* The ZPL_SCIENCE_P1_REDUCED_U_CAM1 product */

     sph_zpl_science_pol_product*    science_di_u_plus_cam1                ; /* The ZPL_SCIENCE_P1_REDUCED_UPLUS_CAM1 product */

     sph_zpl_science_pol_product*    science_di_u_minus_cam1               ; /* The ZPL_SCIENCE_P1_REDUCED_UMINUS_CAM1 product */

     sph_zpl_science_pol_product*    science_di_q_cam2                     ; /* The ZPL_SCIENCE_P1_REDUCED_Q_CAM2 product */

     sph_zpl_science_pol_product*    science_di_q_plus_cam2                ; /* The ZPL_SCIENCE_P1_REDUCED_QPLUS_CAM2 product */

     sph_zpl_science_pol_product*    science_di_q_minus_cam2               ; /* The ZPL_SCIENCE_P1_REDUCED_QMINUS_CAM2 product */

     sph_zpl_science_pol_product*    science_di_u_cam2                     ; /* The ZPL_SCIENCE_P1_REDUCED_U_CAM2 product */

     sph_zpl_science_pol_product*    science_di_u_plus_cam2                ; /* The ZPL_SCIENCE_P1_REDUCED_UPLUS_CAM2 product */

     sph_zpl_science_pol_product*    science_di_u_minus_cam2               ; /* The ZPL_SCIENCE_P1_REDUCED_UMINUS_CAM2 product */

 } sph_zpl_science_p1;
 
 /*-------------------------------------------------------------------------------
  * Error codes
  * 
  * Below the various error codes for this module are declared.
  * ------------------------------------------------------------------------------
  */
 
 int sph_zpl_science_p1_create_test(cpl_plugin *);
 
 
 /*-------------------------------------------------------------------------------
  * The methods
  * 
  * These are the methods for sph_zpl_science_p1.
  * 
  * ------------------------------------------------------------------------------
  */
 
 sph_zpl_science_p1* sph_zpl_science_p1_new( cpl_frameset * frameset, 
                                               cpl_parameterlist * parlist);
 
 sph_error_code  sph_zpl_science_p1_check_frames( sph_zpl_science_p1* self );
 
 sph_error_code sph_zpl_science_p1_check_params( sph_zpl_science_p1* parlist );
 
 cpl_error_code sph_zpl_science_p1_run( sph_zpl_science_p1* self );
 
 sph_error_code sph_zpl_science_p1_delete( sph_zpl_science_p1* self );
 cpl_parameterlist*  sph_zpl_science_p1_create_paramlist(void) CPL_ATTR_ALLOC;
 
 /* Extra function declarations that are defined in sph_zpl_science_p1.c */

 
 /* End of extra function declarations that are defined in sph_zpl_science_p1_run.c */

 
 
 #endif /*SPH_ZPL_SCIENCE_P1_H_*/
 