/***********************************************************************************************/
/******** DANGER !! DANGER !! DANGER !! DO NOT EDIT FILE -- IT WAS GENERATED AUTOMATICALLY !!! */
/***********************************************************************************************/

/* $Id: $
 * This file is part of the SPHERE Pipeline
 * Copyright (C) 2007-2010 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: $
 * $Date: $
 * $Revision: $
 * $Name: $
 */

#include "sph_error.h"
#include "sph_cube.h"
#include "sph_pixel_description_table.h"
#include "sph_ldt.h"
#include "sph_master_frame.h"
#include "sph_double_image.h"
#include "sph_triple_image.h"
#include "sph_quad_image.h"
#include "sph_zpl_exposure.h"
#include "sph_zpl_exposure_imaging.h"
#include "sph_pixel_polyfit_table.h"
#include "sph_ird_instrument_model.h"
#include "sph_fctable.h"
#include "sph_zpl_science_pol_product.h"
#include <cpl.h>
#include <config.h>

#ifndef SPH_ZPL_STAR_CENTER_IMG_H_

#define SPH_ZPL_STAR_CENTER_IMG_H_
#define SPH_ZPL_STAR_CENTER_IMG_VERSION SPHERE_REC_VERSIONS

/*-------------------------------------------------------------------------------
 * The Structure Definition
 * 
 * This structure contains the members of the sph_zpl_star_center_img that are 
 * needed by the various methods.
 * 
 * ------------------------------------------------------------------------------
 */

typedef struct _sph_zpl_star_center_img_ {
    cpl_frameset*                   inframes                              ; /* The recipe input frames */

    cpl_frameset*                   current_raw_frameset                  ; /* The frameset for one product */

    cpl_parameterlist*        inparams                              ; /* The recipe input parameters */

    cpl_parameterlist*        framecomb_parameterlist               ; /* The recipe input parameters */

    const char*                     star_center_img_outfilename           ; /* The parameter of zpl.star_center_img.outfilename */

    const char*                     star_center_img_outfilename_cam1      ; /* The parameter of zpl.star_center_img.outfilename_cam1 */

    const char*                     star_center_img_outfilename_cam2      ; /* The parameter of zpl.star_center_img.outfilename_cam2 */

    short                           subtract_overscan                     ; /* The parameter of zpl.science_p1.subtract_overscan */

    int                             coll_alg                              ; /* The parameter of zpl.star_center_img.coll_alg */

    double                          filter_radius                         ; /* The parameter of zpl.star_center_img.filter_radius */

    double                          sigma                                 ; /* The parameter of zpl.star_center_img.sigma */

    int                             unsharp_window                        ; /* The parameter of zpl.star_center_img.unsharp_window */

    short                           keep_intermediate                     ; /* The parameter of zpl.star_center_img.keep_intermediate */

    short                           save_interprod                        ; /* The parameter of zpl.star_center_img.save_interprod */

    const char*                     outfilename_cam1                      ; /* The parameter of zpl.preproc.outfilename_cam1 */

    const char*                     outfilename_cam2                      ; /* The parameter of zpl.preproc.outfilename_cam2 */

    cpl_frameset*                   rawframes                             ; /* The ZPL_STAR_CENTER_IMG_RAW frames */

    cpl_frameset*                   preproc_frames                        ; /* The ZPL_STAR_CENTER_IMG_PREPROC frames */

    cpl_frameset*                   preproc_frames_cam1                   ; /* The ZPL_STAR_CENTER_IMG_PREPROC_CAM1 frames */

    cpl_frameset*                   preproc_frames_cam2                   ; /* The ZPL_STAR_CENTER_IMG_PREPROC_CAM2 frames */

    cpl_frame*                      master_bias_frame                     ; /* The ZPL_MASTER_BIAS_IMAGING frames */

    cpl_frame*                      master_bias_frame_cam1                ; /* The ZPL_MASTER_BIAS_IMAGING_CAM1 frames */

    cpl_frame*                      master_bias_frame_cam2                ; /* The ZPL_MASTER_BIAS_IMAGING_CAM2 frames */

    cpl_frame*                      master_dark_frame                     ; /* The ZPL_MASTER_DARK_IMAGING frames */

    cpl_frame*                      master_dark_frame_cam1                ; /* The ZPL_MASTER_DARK_IMAGING_CAM1 frames */

    cpl_frame*                      master_dark_frame_cam2                ; /* The ZPL_MASTER_DARK_IMAGING_CAM2 frames */

    cpl_frame*                      intensity_flat_frame                  ; /* The ZPL_INT_FLAT_FIELD_IMAGING frames */

    cpl_frame*                      intensity_flat_frame_cam1             ; /* The ZPL_INT_FLAT_FIELD_IMAGING_CAM1 frames */

    cpl_frame*                      intensity_flat_frame_cam2             ; /* The ZPL_INT_FLAT_FIELD_IMAGING_CAM2 frames */

    sph_double_image*               star_center_img_di                    ; /* The ZPL_STAR_CENTER_IMG product */

    sph_double_image*               star_center_img_di_cam1               ; /* The ZPL_STAR_CENTER_IMG_CAM1 product */

    sph_double_image*               star_center_img_di_cam2               ; /* The ZPL_STAR_CENTER_IMG_CAM2 product */

} sph_zpl_star_center_img;

/*-------------------------------------------------------------------------------
 * Error codes
 * 
 * Below the various error codes for this module are declared.
 * ------------------------------------------------------------------------------
 */

int sph_zpl_star_center_img_create_test(cpl_plugin *);


/*-------------------------------------------------------------------------------
 * The methods
 * 
 * These are the methods for sph_zpl_star_center_img.
 * 
 * ------------------------------------------------------------------------------
 */

sph_zpl_star_center_img* sph_zpl_star_center_img_new( cpl_frameset * frameset, 
                                              cpl_parameterlist * parlist);

sph_error_code  sph_zpl_star_center_img_check_frames( sph_zpl_star_center_img* self );

sph_error_code sph_zpl_star_center_img_check_params( sph_zpl_star_center_img* parlist );

cpl_error_code sph_zpl_star_center_img_run( sph_zpl_star_center_img* self );

sph_error_code sph_zpl_star_center_img_delete( sph_zpl_star_center_img* self );
cpl_parameterlist*  sph_zpl_star_center_img_create_paramlist(void) CPL_ATTR_ALLOC;

/* Extra function declarations that are defined in sph_zpl_star_center_img.c */


/* End of extra function declarations that are defined in sph_zpl_star_center_img_run.c */



#endif /*SPH_ZPL_STAR_CENTER_IMG_H_*/
